unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, FlyingLabel, Menus;

type
  TFThread = class(TThread)
   private
     fl:TFlyingLabel;
   public
     constructor create(suspended:boolean;var fl:TFlyingLabel);
     procedure execute;override;
  end;
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Start1: TMenuItem;
    Stop1: TMenuItem;
    Konec1: TMenuItem;
    L11: TMenuItem;
    L21: TMenuItem;
    L31: TMenuItem;
    L12: TMenuItem;
    L22: TMenuItem;
    L32: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Konec1Click(Sender: TObject);

    procedure L11Click(Sender: TObject);
    procedure L21Click(Sender: TObject);
    procedure L31Click(Sender: TObject);
    procedure L12Click(Sender: TObject);
    procedure L22Click(Sender: TObject);
    procedure L32Click(Sender: TObject);
  private
     { Private declarations }
     fl1,fl2,fl3:TFlyingLabel;
     ft1,ft2,ft3:TFThread;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
 fl1 := TFlyingLabel.Create(self);
 fl1.parent := self;
 fl1.Top := 10;
 fl1.Left := 10;
 fl1.Caption := 'L1';
 fl1.speedX := 10;
 fl1.speedY := 1;
 fl2 := TFlyingLabel.Create(self);
 fl2.parent := self;
 fl2.Top := 10;
 fl2.Left := 10;
 fl2.Caption := 'L2';
 fl2.speedX := 5;
 fl2.speedY := 5;
 fl3 := TFlyingLabel.Create(self);
 fl3.parent := self;
 fl3.Top := 10;
 fl3.Left := 10;
 fl3.Caption := 'L3';
 fl3.speedX := 1;
 fl3.speedY := 10;
 ft1 := TFThread.create(true,fl1);
 ft2 := TFThread.Create(true,fl2);
 ft3 := TFThread.create(true,fl3);
end;


procedure TForm1.Konec1Click(Sender: TObject);
begin
 Application.Terminate;
end;

{ TFThread }

constructor TFThread.create(suspended: boolean; var fl: TFlyingLabel);
begin
 inherited create(suspended);
 self.fl := fl;
end;

procedure TFThread.execute;
begin
 while true do
 begin
  synchronize(fl.move);
  sleep(100);
 end;
end;


procedure TForm1.L11Click(Sender: TObject);
begin
 ft1.Resume;
 l11.Enabled:=false;
 l12.Enabled:=true;
end;

procedure TForm1.L21Click(Sender: TObject);
begin
 ft2.Resume;
 l21.Enabled:=false;
 l22.Enabled:=true;
end;

procedure TForm1.L31Click(Sender: TObject);
begin
 ft3.Resume;
 l31.Enabled:=false;
 l32.Enabled:=true;
end;

procedure TForm1.L12Click(Sender: TObject);
begin
 ft1.Suspend;
 l11.Enabled := true;
 l12.Enabled := false;
end;

procedure TForm1.L22Click(Sender: TObject);
begin
 ft2.Suspend;
 l21.Enabled := true;
 l22.Enabled := false;
end;

procedure TForm1.L32Click(Sender: TObject);
begin
 ft3.Suspend;
 l31.Enabled := true;
 l32.Enabled :=false;
end;

end.
