unit FlyingLabel;

interface

uses
  SysUtils, Classes, Controls, StdCtrls;

type
  TFlyingLabel = class(TLabel)
  private
    vx,vy:integer;
    function getVX:integer;
    function getVY:integer;
    procedure setVX(vx:integer);
    procedure setVY(vy:integer);
    { Private declarations }
  protected
    { Protected declarations }
  public
    procedure move;
    { Public declarations }
  published
    property speedX:integer read getVX write setVX;
    property speedY:integer read getVY write setVY;
    { Published declarations }
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TFlyingLabel]);
end;

{ TFlyingLabel }

function TFlyingLabel.getVX: integer;
begin
  getVX := vx;
end;

function TFlyingLabel.getVY: integer;
begin
 getVY := vy;
end;

procedure TFlyingLabel.move;
var rodic:TWinControl;
   width,height:integer;
begin
 if self.Parent is TWinControl then
 begin
  rodic := self.Parent as TWinControl;
  width := rodic.Width;
  height := rodic.Height;
  self.Top := self.Top + vy;
  if self.Top < 0 then self.Top := height - self.Height;
  if self.Top > height - self.Height then self.Top := 0;
  self.Left := self.Left + vx;
  if self.left < 0 then self.Left := width - self.Width;
  if self.left > width - self.Width then self.left := 0;
 end
end;

procedure TFlyingLabel.setVX(vx: integer);
begin
 self.vx := vx;
end;

procedure TFlyingLabel.setVY(vy: integer);
begin
 self.vy := vy;
end;

end.
